"""
    Criteo API

    Criteo API - MarketingSolutions  # noqa: E501

    The version of the OpenAPI document: preview
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from criteo_api_marketingsolutions_preview.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from criteo_api_marketingsolutions_preview.exceptions import ApiAttributeError



class StatisticsRecord(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'start_date': (datetime,),  # noqa: E501
            'end_date': (datetime,),  # noqa: E501
            'total': (int,),  # noqa: E501
            'variant': (int,),  # noqa: E501
            'displayable': (int,),  # noqa: E501
            'non_displayable': (int,),  # noqa: E501
            'added': (int,),  # noqa: E501
            'deleted': (int,),  # noqa: E501
            'updated': (int,),  # noqa: E501
            'blacklisted': (int,),  # noqa: E501
            'out_of_stock': (int,),  # noqa: E501
            'missing_image': (int,),  # noqa: E501
            'missing_url': (int,),  # noqa: E501
            'missing_price': (int,),  # noqa: E501
            'missing_name': (int,),  # noqa: E501
            'missing_description': (int,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'start_date': 'startDate',  # noqa: E501
        'end_date': 'endDate',  # noqa: E501
        'total': 'total',  # noqa: E501
        'variant': 'variant',  # noqa: E501
        'displayable': 'displayable',  # noqa: E501
        'non_displayable': 'nonDisplayable',  # noqa: E501
        'added': 'added',  # noqa: E501
        'deleted': 'deleted',  # noqa: E501
        'updated': 'updated',  # noqa: E501
        'blacklisted': 'blacklisted',  # noqa: E501
        'out_of_stock': 'outOfStock',  # noqa: E501
        'missing_image': 'missingImage',  # noqa: E501
        'missing_url': 'missingUrl',  # noqa: E501
        'missing_price': 'missingPrice',  # noqa: E501
        'missing_name': 'missingName',  # noqa: E501
        'missing_description': 'missingDescription',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, start_date, end_date, total, variant, displayable, non_displayable, added, deleted, updated, blacklisted, out_of_stock, missing_image, missing_url, missing_price, missing_name, missing_description, *args, **kwargs):  # noqa: E501
        """StatisticsRecord - a model defined in OpenAPI

        Args:
            start_date (datetime): Start date of streaming products collection
            end_date (datetime): End date of streaming products collection
            total (int): The number of total products at endDate moment
            variant (int): The number of total variant products at endDate moment
            displayable (int): The number of total displayable products at endDate moment
            non_displayable (int): The number of total non-displayable products at endDate moment
            added (int): The number of inserted products during the period between startDate and endDate
            deleted (int): The number of deleted products during the period between startDate and endDate
            updated (int): The number of updated products during the period between startDate and endDate
            blacklisted (int): The number of total blacklisted products at endDate moment
            out_of_stock (int): The number of total out-of-stock products at endDate moment
            missing_image (int): The number of total missing image products at endDate moment
            missing_url (int): The number of total missing url products at endDate moment
            missing_price (int): The number of total missing price products at endDate moment
            missing_name (int): The number of total missing name products at endDate moment
            missing_description (int): The number of total missing description products at endDate moment

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.start_date = start_date
        self.end_date = end_date
        self.total = total
        self.variant = variant
        self.displayable = displayable
        self.non_displayable = non_displayable
        self.added = added
        self.deleted = deleted
        self.updated = updated
        self.blacklisted = blacklisted
        self.out_of_stock = out_of_stock
        self.missing_image = missing_image
        self.missing_url = missing_url
        self.missing_price = missing_price
        self.missing_name = missing_name
        self.missing_description = missing_description
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, start_date, end_date, total, variant, displayable, non_displayable, added, deleted, updated, blacklisted, out_of_stock, missing_image, missing_url, missing_price, missing_name, missing_description, *args, **kwargs):  # noqa: E501
        """StatisticsRecord - a model defined in OpenAPI

        Args:
            start_date (datetime): Start date of streaming products collection
            end_date (datetime): End date of streaming products collection
            total (int): The number of total products at endDate moment
            variant (int): The number of total variant products at endDate moment
            displayable (int): The number of total displayable products at endDate moment
            non_displayable (int): The number of total non-displayable products at endDate moment
            added (int): The number of inserted products during the period between startDate and endDate
            deleted (int): The number of deleted products during the period between startDate and endDate
            updated (int): The number of updated products during the period between startDate and endDate
            blacklisted (int): The number of total blacklisted products at endDate moment
            out_of_stock (int): The number of total out-of-stock products at endDate moment
            missing_image (int): The number of total missing image products at endDate moment
            missing_url (int): The number of total missing url products at endDate moment
            missing_price (int): The number of total missing price products at endDate moment
            missing_name (int): The number of total missing name products at endDate moment
            missing_description (int): The number of total missing description products at endDate moment

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.start_date = start_date
        self.end_date = end_date
        self.total = total
        self.variant = variant
        self.displayable = displayable
        self.non_displayable = non_displayable
        self.added = added
        self.deleted = deleted
        self.updated = updated
        self.blacklisted = blacklisted
        self.out_of_stock = out_of_stock
        self.missing_image = missing_image
        self.missing_url = missing_url
        self.missing_price = missing_price
        self.missing_name = missing_name
        self.missing_description = missing_description
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
